<template>
  <div class="page_container">
    <Separator
      @click="
        () => {
          libraryToggle(0);
        }
      "
      v-if="state.page.page_structure.length == 0"
    />
    <Library
      :onChoose="updateStructure"
      :onClose="libraryToggle"
      :opened="state.library.opened"
    />
    <Editor
      :onSave="updateItemProps"
      :component="state.editor.component"
      :data="state.editor.data"
      :onClose="editorToggle"
      :opened="state.editor.opened"
    />

    <div
      class="editItem"
      v-for="(item, index) in state.page.page_structure"
      :key="index"
    >
      <div class="editArea">
        <button
          @click="
            () => {
              editorToggle(index);
            }
          "
        >
          <Icon size="28px" src="edit" color="var(--color)" />
        </button>
        <button
          @click="
            () => {
              removeItem(index);
            }
          "
        >
          <Icon size="28px" src="delete" color="var(--color)" />
        </button>
        <button
          @click="
            () => {
              upItem(index);
            }
          "
          v-if="index != 0"
        >
          <Icon size="28px" src="arrow-up" color="var(--color)" />
        </button>
        <button
          @click="
            () => {
              downItem(index);
            }
          "
          v-if="index + 1 < state.page.page_structure.length"
        >
          <Icon size="28px" src="arrow-down" color="var(--color)" />
        </button>
      </div>
      <component
        :is="item"
        v-bind="state.page.page_data[index].props"
        :style="{
          boxShadow:
            state.editor.index == index
              ? 'inset 0 0 0 3px var(--primary-color)'
              : '',
        }"
      >
        <template
          v-slot:[name]
          v-for="(slot, name) in state.page.page_data[index].slots"
          :key="name"
        >
          {{ slot }}
        </template>
      </component>
      <Separator
        @click="
          () => {
            libraryToggle(index + 1);
          }
        "
      />
    </div>
  </div>
</template>

<script>
import { computed, onMounted, onUnmounted, reactive, watchEffect, watch } from "vue";
import { useRoute } from "vue-router";
import { useStore } from "vuex";
import site_components from "sc/index";
import Separator from "ac/Constructor/Separator";
import Library from "ac/Constructor/Library";
import Editor from "ac/Constructor/Editor";
import Icon from "ac/Icon";
export default {
  components: {
    Separator,
    Library,
    Editor,
    Icon,
    ...site_components.sections,
  },
  props: ['setName'],
  setup(props) {
    const store = useStore();
    const route = useRoute(route);
    const state = reactive({
      library: {
        opened: false,
        index: null,
      },
      editor: {
        opened: false,
        index: null,
        component: null,
        data: null,
      },
      page: {
        page_structure: [],
        page_data: [{}]
      },
      history: {
        currPos: 0,
        pages: [],
      },
    });
    const serverSidePage = computed(() => {
      return store.getters["pages/getPageBySlug"](route.params.page);
    });

    function keydownHandler(event) {
      function undoHandler() {
        console.log("try to undo");
        if (state.history.currPos == 0) {
          console.log("undo impossible");
          return false;
        }

        console.log("set to ", state.history.currPos - 1)
        console.log(state.history.pages)

        state.page = state.history.pages[state.history.currPos - 1];
        state.history.currPos = state.history.currPos - 1;

        save()
      }

      function redoHandler() {
        console.log("try to redo");
        if (state.history.currPos == state.history.pages.length - 1) {
          console.log("redo impossible");
          return false;
        }

        console.log("set to ", state.history.currPos + 1)

        state.page = state.history.pages[state.history.currPos + 1];
        state.history.currPos = state.history.currPos + 1;

        save()
      }

      function save(){
        store.dispatch("pages/savePage", {
          page_data: state.page.page_data,
          page_structure: state.page.page_structure,
          page_slug: route.params.page,
        });
      }
      
      if (event.ctrlKey && event.code === "KeyZ") {
        undoHandler();
      } else if (event.ctrlKey && event.code === "KeyY") {
        redoHandler();
      }
    }

    onMounted(async () => {
      store.dispatch("pages/getData");
      window.addEventListener("keyup", keydownHandler);
    });

    onUnmounted(async () => {
      window.removeEventListener("keyup", keydownHandler);
      props.setName(undefined);
    });

    watch(
      () => serverSidePage.value,
      (curr) => {
        state.page.page_structure = curr
        ? curr.page_structure
        : [];

        state.page.page_data = curr
          ? curr.page_data
          : [];

        props.setName(curr && curr.page_slug);

        state.history.pages[0] = {
          page_structure: curr
            ? [...curr.page_structure]
            : [],
          page_data: curr
            ? [...curr.page_data]
            : [],
        };
      }
    )

    watchEffect(() => {});

    return {
      sections: site_components.sections,
      state,
    };
  },
  methods: {
    libraryToggle(index = null) {
      const newState = !this.state.library.opened;
      this.state.library.opened = newState;
      if (newState) {
        this.state.library.index = index;
      } else {
        this.state.library.index = null;
      }
    },
    editorToggle(index = null) {
      const newState = !this.state.editor.opened;
      this.state.editor.opened = newState;
      if (newState) {
        this.state.editor.index = index;
        this.state.editor.component = this.state.page.page_structure[index];
        this.state.editor.data = this.state.page.page_data[index];
      } else {
        this.state.editor.index = null;
      }
    },
    removeItem(index) {
      this.state.page.page_structure.splice(index, 1);
      this.state.page.page_data.splice(index, 1);


      this.addToHistory();
      this.save();
    },
    updateStructure(component) {
      const index = this.state.library.index;
      this.state.page.page_structure.splice(index, 0, component.toString());
      this.state.page.page_data.splice(index, 0, {
        props: Object.fromEntries(
          Object.keys(site_components.sections[component].props).map((prop) => [
            prop,
            site_components.sections[component].props[prop].init_val,
          ])
        ),
      });


      this.addToHistory();
      this.save();
    },
    updateItemProps(data) {
      this.state.page.page_data[this.state.editor.index] = data;
      this.state.editor.data = data;

      this.addToHistory();
      this.save();
    },
    downItem(index) {
      const tmp = this.state.page.page_structure[index + 1];
      this.state.page.page_structure[
        index + 1
      ] = this.state.page.page_structure[index];
      this.state.page.page_structure[index] = tmp;

      const tmp_data = this.state.page.page_data[index + 1];
      this.state.page.page_data[index + 1] = this.state.page.page_data[index];
      this.state.page.page_data[index] = tmp_data;

      this.addToHistory();
      this.save();
    },
    upItem(index) {
      const tmp = this.state.page.page_structure[index - 1];
      this.state.page.page_structure[
        index - 1
      ] = this.state.page.page_structure[index];
      this.state.page.page_structure[index] = tmp;

      const tmp_data = this.state.page.page_data[index - 1];
      this.state.page.page_data[index - 1] = this.state.page.page_data[index];
      this.state.page.page_data[index] = tmp_data;

      this.addToHistory();
      this.save();
    },
    addToHistory() {
      const newHistory = [...this.state.history.pages];
      newHistory.length = this.state.history.currPos + 1;
      const newPos = this.state.history.currPos + 1;

      newHistory[newPos] = {
        page_data: [...this.state.page.page_data],
        page_structure: [...this.state.page.page_structure],
      };

      this.state.history.pages = newHistory;
      this.state.history.currPos = newPos;
    },
    save() {
      this.$store.dispatch("pages/savePage", {
        page_data: this.state.page.page_data,
        page_structure: this.state.page.page_structure,
        page_slug: this.$route.params.page,
      });
    },
  },
};
</script>

<style scoped lang="scss">
.page_container {
  position: relative;
  padding: 0;
  margin: 0 -8px;
}

.sec {
  width: 100%;
  height: 400px;
  background: #888888;
}

.editItem {
  position: relative;

  &:last-of-type{
    .separator{
      position: relative;
    }
  }

  .editArea {
    position: absolute;
    top: 0;
    right: 0;
    padding: 4px;
    z-index: 3;
    opacity: 0;
    transition: 0.3s ease all;

    button {
      padding: 0;
      margin: 0;
      border: none;
      outline: none;
      background: transparent;
      --color: var(--primary-color);

      border: 2px solid var(--color);
      border-radius: 50%;
      padding: 4px;
      transition: all 0.3s ease;
      &:hover {
        --color: #ffffff;
        background: var(--primary-dark-1-color);
        border: 2px solid var(--primary-dark-1-color);
      }
      &:not(:last-child) {
        margin-right: 8px;
      }
    }
  }

  &:hover {
    .editArea {
      opacity: 1;
    }
  }
}
</style>
